from enum import Enum

class Unsupervised(Enum):
    ALL_FEATURES_EX_POSE = 'ALL FEATURES (EXCLUDING POSE)'
    DATA_SLICE_SELECTION = 'data_slice'
    CLF_SLICE_SELECTION = 'clf_slice'
    NAMES = 'NAMES'
    START_FRAME = 'START_FRAME'
    END_FRAME = 'END_FRAME'
    CLASSIFIER = 'CLASSIFIER'
    SCALER_NAMES = ['MIN-MAX', 'STANDARD', 'QUANTILE']
    PROBABILITY = 'PROBABILITY'
    USER_DEFINED_SET = 'USER-DEFINED FEATURE SET'
    FRAME = 'FRAME'
    VIDEO = 'VIDEO'
    FEATURE_PATH = 'feature_path'
    BOUT_AGGREGATION_TYPE = 'bout_aggregation_type'
    MIN_BOUT_LENGTH = 'min_bout_length'
    N_NEIGHBORS = 'n_neighbors'
    HASHED_NAME = 'HASH'
    DATA = 'DATA'
    RAW = 'RAW'
    SCALER_TYPE = 'SCALER_TYPE'
    CSV = 'CSV'
    FORMAT = 'format'
    SCALED_DATA = 'SCALED_DATA'
    PARAMETERS = 'PARAMETERS'
    METHODS = 'METHODS'
    DR_MODEL = 'DR_MODEL'
    MODEL = 'MODEL'
    MIN_DISTANCE = 'min_distance'
    EUCLIDEAN = 'euclidean'
    FEATURE_NAMES = 'FEATURE_NAMES'
    SPREAD = 'spread'
    SCALER = 'scaler'
    SCALED = 'scaled'
    VARIANCE = 'variance'
    HYPERPARAMETERS = [N_NEIGHBORS, MIN_DISTANCE, SPREAD, SCALER, VARIANCE]
    FRAME_FEATURES = 'FRAME_FEATURES'
    FRAME_POSE = 'FRAME_POSE'
    FRAME_TARGETS = 'FRAME_TARGETS'
    BOUTS_FEATURES = 'BOUTS_FEATURES'
    BOUTS_TARGETS = 'BOUTS_TARGETS'
    DATASET_DATA_FIELDS = [FRAME_FEATURES, FRAME_POSE, FRAME_TARGETS, BOUTS_FEATURES, BOUTS_TARGETS]
    MIN_MAX = 'MIN-MAX'
    STANDARD = 'STANDARD'
    QUANTILE = 'QUANTILE'
    LOW_VARIANCE_FIELDS = 'LOW_VARIANCE_FIELDS'


class Clustering(Enum):
    ALPHA = 'alpha'
    MIN_CLUSTER_SIZE = 'min_cluster_size'
    MIN_SAMPLES = 'min_samples'
    EPSILON = 'cluster_selection_epsilon'
    CLUSTER_MODEL = 'CLUSTER_MODEL'
